#!c:/perl/bin/perl.exe
use warnings;
use strict;
use CGI::Carp qw(fatalsToBrowser);
use HTML::Template;
use CGI qw(param upload);

print "Content-type: text/html\n\n";

my $templates_dir = 'D:/Templates/Course';

chdir $templates_dir or die "Can't move to templates dir: $!";

my $file_name = param('fasta');

if ($file_name) {
	print_stats();
}
else {
	print_form();
}

sub print_form {
	my $template = HTML::Template->new(filename => '9_fasta_form.html');
	print $template->output();	
}

sub print_stats {
	
	my $template = HTML::Template->new(filename => '9_fasta_stats.html');
	

	my $filehandle = upload('fasta');
	
	my $header = <$filehandle>;
	unless ($header =~ /^>/) {
		die "File didn't look like fasta to me";
	}
	
	my %letters;
	while (<$filehandle>) {
		chomp;
		s/\s+//g;
		$_ = lc($_);
		my @letters = split(//);
		foreach my $letter (@letters) {
			++$letters{$letter};
		}
	}
	
	my $stats;
	
	foreach my $letter (sort {$letters{$b}<=>$letters{$a}} keys %letters) {
		push @$stats, {LETTER => $letter, COUNT => $letters{$letter}};
	}
	
	$template -> param(FILENAME => param('fasta'),
		   		       STATS => $stats);
		   		       
	print $template -> output();
}
